%Define sample frequency
sf = 48000;

%Define pure tones for "instrument"
c3 = pureTone(130.81,0.2,0.5);
d3 = pureTone(146.83,0.2,0.5);
e3 = pureTone(164.81,0.2,0.5);
f3 = pureTone(174.61,0.2,0.5);
g3 = pureTone(196.00,0.2,0.5);
a3 = pureTone(220.00,0.2,0.5);
b3 = pureTone(246.94,0.2,0.5);
c4 = pureTone(261.63,0.2,0.5);
d4 = pureTone(293.66,0.2,0.5);
e4 = pureTone(329.63,0.2,0.5);
f4 = pureTone(349.23,0.2,0.5);
g4 = pureTone(392.00,0.2,0.5);
a4 = pureTone(440.00,0.2,0.5);
b4 = pureTone(493.88,0.2,0.5);
c5 = pureTone(523.25,0.2,0.5);
d5 = pureTone(587.33,0.2,0.5);
e5 = pureTone(659.26,0.2,0.5);
f5 = pureTone(698.46,0.2,0.5);
g5 = pureTone(783.99,0.2,0.5);
a5 = pureTone(880.00,0.2,0.5);
b5 = pureTone(987.77,0.2,0.5);

notes = [c3 ; d3 ; e3 ; f3 ; g3 ; a3 ; b3 ; ...
    c4 ; d4 ; e4 ; f4 ; g4 ; a4 ; b4; ...
    c5 ; d5 ; e5 ; f5 ; g5 ; a5 ; b5];

%Starting condition
start = [ 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0];

%Wolfram's Rule 30 Music
current = start;
history30 = [];
song30 = [];
for i=1:50
    new = [];
    for j=1:length(current)
        
        if j==1
            left = length(current);
            right = j+1;
        elseif j==length(current)
            left = j-1;
            right = 1;
        else
            left = j-1;
            right = j+1;
        end
        
        if ((current(left) == 1) && (current(j) == 1) && (current(right) == 1)) || ...
           ((current(left) == 1) && (current(j) == 1) && (current(right) == 0)) || ...
           ((current(left) == 1) && (current(j) == 0) && (current(right) == 1)) || ...
           ((current(left) == 0) && (current(j) == 0) && (current(right) == 0))
            new(j) = 0;
        else
            new(j) = 1;
        end
    end
    
    history30 = [history30 ; current];
    
    chord = zeros(1,length(notes));
    count = 0;
    for k=1:length(current)
        if current(k) == 1
            chord = chord + notes(k,:);
            count = count + 1;
        end
    end
    
    if count > 0
        chord = chord / count;
    end
    
    song30 = [song30 chord];
    current = new;
end

imwrite(history30*255,'rule30.png','png')
wavwrite(song30,sf,'rule30.wav')

%Wolfram's Rule 90 Music
current = start;
history90 = [];
song90 = [];
for i=1:50
    new = [];
    for j=1:length(current)
        
        if j==1
            left = length(current);
            right = j+1;
        elseif j==length(current)
            left = j-1;
            right = 1;
        else
            left = j-1;
            right = j+1;
        end
        
        if ((current(left) == 1) && (current(j) == 1) && (current(right) == 1)) || ...
           ((current(left) == 1) && (current(j) == 0) && (current(right) == 1)) || ...
           ((current(left) == 0) && (current(j) == 1) && (current(right) == 0)) || ...
           ((current(left) == 0) && (current(j) == 0) && (current(right) == 0))
            new(j) = 0;
        else
            new(j) = 1;
        end
    end
    
    history90 = [history90 ; current];
    
    chord = zeros(1,length(notes));
    count = 0;
    for k=1:length(current)
        if current(k) == 1
            chord = chord + notes(k,:);
            count = count + 1;
        end
    end
    
    if count > 0
        chord = chord / count;
    end
    
    song90 = [song90 chord];
    current = new;
end

imwrite(history90*255,'rule90.png','png')
wavwrite(song90,sf,'rule90.wav')
